package activity;

import java.io.IOException;
import java.util.Vector;


import gui.Configuration;
import interfaces.IActivityMonitor;
import interfaces.StatAggregator;

public class ActivityListenerMultiProxy extends WaitIntegerActivityMonitor implements IActivityMonitor {

	Vector<ActivityListenerProxy> pool;
	
	public ActivityListenerMultiProxy (int nbnodes) {
		pool = new Vector<ActivityListenerProxy> (nbnodes);
		for (int i =0; i< nbnodes ; i++) {
			pool.add(createAL(i));
		}
	}
	
	protected ActivityListenerProxy createAL(int i) {
		ActivityListenerProxy nss = new ActivityListenerProxy(this);
		nss.setServer(Configuration.getConf().getHostIP(i), Configuration.getConf().getAMPort(i));
		try {
			nss.connect();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return nss;
	}


	public void getStats(StatAggregator stats) {
		super.getStats(stats);
		stats.agregate("ActivityListenerMultiProxy containing :");
		for (ActivityListenerProxy a: pool) {
			if (a == null) {
				stats.agregate("null entry");
			} else {
				a.getStats(stats);
			}
		}
	}
}