package activity;

import interfaces.IActivityMonitor;
import protocol.Message;
import protocol.MsgType;
import protocol.TCPServeurMessage;

public class ActivityListenerService extends TCPServeurMessage {
	
	
	private static final boolean DEBUG = true;
	private IActivityMonitor concreteAL;
	
	public ActivityListenerService (IActivityMonitor al) {
		concreteAL = al;
	}
	
	public void gereClient() {
		try {
			while (true) {
				Message m = getMessage();
				switch (m.head) 
				{
				case  WAIT_UNTIL_ACTIVE : {
					concreteAL.waitUntilActive();
					sendMessage(new Message(MsgType.ACK_OK));
					break;
				}
				case  WAIT_UNTIL_INACTIVE : {
					concreteAL.waitUntilInactive();
					sendMessage(new Message(MsgType.ACK_OK));
					break;
				}
				case IS_ACTIVE_REQ : {
					if (concreteAL.isActive())
						sendMessage(new Message(MsgType.ACK_OK));
					else
						sendMessage(new Message(MsgType.ACK_NOK));
					break;
				}
				default : {
					System.err.println("received strange message in ActivityListener gereClient()");
				}
				}
			}
		} catch (NullPointerException e) { 
			if (DEBUG)
				System.err.println("activity listener thread ended on demand");
		} catch (Exception e) {
			System.err.println("activity listener thread ended "+e);
			return ;
		}
	}
	
}
