package basic;

import interfaces.IActivityMonitor;
import interfaces.IState;
import interfaces.IStateSet;
import interfaces.StatAggregator;

import java.util.ArrayList;


public class StateSetArrayAdapter extends IntegerActivityMonitor implements IStateSet,IActivityMonitor {

	ArrayList<IState> states_;
	
	public StateSetArrayAdapter() {
		states_ = new ArrayList<IState> ();
	}
	
	
	public synchronized IState popState() throws InterruptedException {
		if (states_.isEmpty()) {
			notifyInactivity();
			wait();
				
			while (states_.isEmpty()) {
				wait();
			}
			
			notifyActivity();
		}
		if (states_.size() == 1)
			notifyInactivity();
		return states_.remove(0);
	}

	synchronized public void pushState(IState s) {		
		states_.add(s);
		if (states_.size() == 1) {
			notifyActivity();
			notifyAll();
		}
	}
	

	public boolean isEmpty() {
		return states_.isEmpty();
	}




	public void getStats(StatAggregator stats) {
		super.getStats (stats);
		stats.agregate("\n Array State Set contains :" + states_.size()  );
	}

	synchronized public void close() {
		super.close();
		states_=null;
		notifyAll();
	}
}
