package cluster;

import java.io.IOException;

import interfaces.IFiringManager;
import interfaces.StatAggregator;
import protocol.Message;
import protocol.MsgType;
import protocol.TCPClientMessage;

public class FiringManagerProxy extends TCPClientMessage implements
		IFiringManager {

	public void processInitialState() {
		try {
			sendMessage(new Message(MsgType.PROCESS_INITIAL_REQ));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void startGeneration() {
		try {
			sendMessage(new Message(MsgType.START_GEN_REQ));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void getStats(StatAggregator stats) {
		try {
			sendMessage(new Message(MsgType.STATS_REQ));
			Message m = getMessage();
			assert(m.head == MsgType.STATS_RESP);
			stats.agregate(m.data.get(0));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void close() {
		disconnect();
	}
}
