package dhash;

import interfaces.IState;
import interfaces.IStateManager;
import interfaces.StatAggregator;

import java.io.IOException;

import protocol.Message;
import protocol.MsgType;
import protocol.TCPServeurMessage;


public class StateManagerService extends TCPServeurMessage implements Cloneable {

	private IStateManager concreteSM_;
	
	public StateManagerService (IStateManager sm) {
		concreteSM_ = sm;
	}
	
	public void gereClient() {
		try {
		while (true) {
			Message m = getMessage();
			switch (m.head) {
			case  PROCESS_STATE : {
				concreteSM_.processState((IState) m.data.get(0));
				// void reply for more asynchronism
				break;
			}

			case ELEMENTS_REQ : {
				// no implem , seems stupid right now to send all states to somebody
				// callers should send a callback class with code that is run on concrete
				// then packaged back to the caller
				// I will try to write this later in java, using serializable
				// but i'm not sure how costly porting to c++ might be
				try {
					CallBack<IStateManager> cb = ((CallBack<IStateManager>) m.data.get(0));
					cb.callBack(concreteSM_);
					sendMessage(new Message(MsgType.ELEMENTS_RESP , cb));
				} catch (ClassCastException e) {
					System.err.println("Expected a callback in cast ! Terminating !"); 
					e.printStackTrace();	
					return;
				}
				break;
			}
			case STATS_REQ :  {
				StatAggregator s = new StatAggregator();
				concreteSM_.getStats(s);
				sendMessage(new Message(MsgType.STATS_RESP,s));
				break;
			}
			case QUIT : {
				stopServer();
				return ;
			}
			}
		}
		} catch (IOException e){
			return;
		}
	}
}

