package gui;

import java.io.Serializable;
import java.net.InetAddress;
import java.net.UnknownHostException;

// a Serializable struct to hold node configs
public class NodeConfiguration implements Serializable {
	InetAddress ip = null;
	int smPort = 1664;
	int nssPort = 1665;
	int fmPort = 1666;
	int amPort = 1667;
	String localPath="/tmp/dmc/";
	
	public NodeConfiguration(InetAddress a) {
		ip = a ;
	}
	
	public boolean equals (Object o) {
		if (o instanceof InetAddress)
			return o.equals(ip);
		else
			return false;
	}
	
	public String toString () {
		return "Configuration : smPort="+smPort+ " host "+ ip
		+ " nssPort="+ nssPort+ " fmPort="+fmPort +" amPort=" +amPort;
	}

	public void setHostName(String host) throws UnknownHostException {
		ip = InetAddress.getByName(host);
	}

	public int getAmPort() {
		return amPort;
	}
	public int getFmPort() {
		return fmPort;
	}
	public int getNssPort() {
		return nssPort;
	}
	public int getSmPort() {
		return smPort;
	}
	public void setAmPort(int amPort) {
		this.amPort = amPort;
	}
	public void setFmPort(int fmPort) {
		this.fmPort = fmPort;
	}
	public void setNssPort(int nssPort) {
		this.nssPort = nssPort;
	}
	public void setSmPort(int smPort) {
		this.smPort = smPort;
	}
	
	public InetAddress getIP() {
		return ip;
	}

	public String getLocalPath() {
		return localPath;
	}
	public void setLocalPath(String localPath) {
		this.localPath = localPath;
	}

}