package ipn;
/*** a few structs */

/** Package visibility struct.
 * To hold a resolved transition, expected to be a unitary transition.
 * Also hold path to it to allow correct place references.
 */
public class ResolvedTrans {
	/** Qualified path to this instance of the transition. 
	 * e.g. : philos.p1
	 * */
	private String path;
	/** Target transition (in a type).
	 * e.g. : public transition getRight { input WaitRight; output HasRight }
	 * We use path to resolve into : input philos.p1.WaitRight; output philos.p1.HasRight
	 * */
	private IPNTransition trans;
	
	public ResolvedTrans(String path, IPNTransition trans) {
		this.path = path;
		this.trans = trans;
	}
	
	public String getPath() {
		return path;
	}
	public void setPath(String path) {
		this.path = path;
	}
	public IPNTransition getTrans() {
		return trans;
	}
	public void setTrans(IPNTransition trans) {
		this.trans = trans;
	}
}