package ipn.composite;

import libpetri.nets.IPTNet;
import ipn.IPNTransition;
import ipn.Visibility;

public class Synchronization extends BasicSynchronization implements IPNTransition {

	private Visibility vis;
	private String name;
	private SyncType st;

	public Synchronization( String name, Visibility vis, SyncType st) {
		this.vis = vis;
		this.name = name;
		this.st = st;
	}

	public String getName() {
		return name;
	}

	public Visibility getVisibility() {
		return vis;
	}


	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("\t"+vis.toString().toLowerCase()+" "+st+" synchronization "+name + " {\n");
		sb.append(super.toString());
		sb.append("\t}\n");
		return sb.toString();
	}

	public SyncType getType() {
		return st;
	}

	public void flatten(IPTNet receiver, String tname, String path) {
		throw new UnsupportedOperationException("Flatten is only significant for unitary transitions.");
	}

	
}
