package ipn.parser;

import ipn.IPNModel;
import ipn.composite.CompositeState;

import java.io.FileInputStream;

import libpetri.ami.AMInet;
import libpetri.dot.DOTnet;

import org.antlr.runtime.ANTLRInputStream;
import org.antlr.runtime.CommonTokenStream;

public class parserTest {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		FileInputStream fis = new FileInputStream("ipn/philo/philo3.ipn");
		ANTLRInputStream is = new ANTLRInputStream(fis);
		ipnLexer l = new ipnLexer(is);
		CommonTokenStream cts = new CommonTokenStream(l);
		ipnParser p = new ipnParser(cts);
		IPNModel mod = p.ipnModel();
		mod.setInitialState("default");
		System.out.println(mod);
		
		// mod.buildStateSpace();
		AMInet cami = new AMInet();
		DOTnet net = new DOTnet("philos","ipn/philo3");
		mod.flatten(cami);
		mod.flatten(net);
		net.close();
		cami.writeNet("ipn/philo3.cami");
		
	//	System.out.println(CompositeState.getUnicityStats ());
	}

}
