package libpetri.nets;

import java.util.Collection;

import libpetri.graphics.ArcGraphics;
import libpetri.structure.ITransition;
import libpetri.structure.arcs.ArcType;

public interface ISymmetricNet extends IPTNet {

	public boolean createTypeDef(String typename, String clinames);
	public boolean createDomain(String domName, String domElts);
	
	/** Creates a place of this domain.
	 * 
	 * @param place : the place name
	 * @param domain : the place domain
	 */
	public boolean createPlace(String place, String domain);

	public boolean setPlaceState(String name, String mark);
	
	public boolean createArc(String pname, String tname, ArcType at, String func, ArcGraphics g);
	public boolean createArc(String pname, String tname, ArcType at, String func);
	
	public Collection<ITransition> getPublicTransitions();

}