package libpetri.structure;

import java.util.Enumeration;

import libpetri.structure.state.State;
import libpetri.tensor.ITensorIterator;


public class SuccIterator implements Enumeration<State> {

	private ITransition t;
	private ITensorIterator it;
	private State s;

	public SuccIterator(ITransition transition, BindingSet bs, State s) {
		this.t = transition;
		this.it = bs.getIterator();
		this.s = s;
	}

	public boolean hasMoreElements() {		
		return it.hasNext();
	}

	public State nextElement() {
		int [] bind = it.next();
		State s2 = s.copy();
		t.fire(s2, bind);
		return s2.unique(t.getContainer());
	}

}
