package libpetri.structure;

import java.util.Enumeration;

import libpetri.namespaces.NamedElement;
import libpetri.namespaces.Namespace;
import libpetri.namespaces.NamingException;

public class TypeDef extends Namespace {

	private int nextIndex=0;

	public TypeDef(String name,String c) {
		super(name);

		for (String n : c.split(",")) {
			try {
				add(new Element(n,nextIndex));
				nextIndex++;
			} catch (NamingException e) {
				System.err.println("Error inserting element "+n+" into type "+name +": name already exists");
				e.printStackTrace();
			}
		}
	}

	public int getIndex(String elt) {		
		try {
			return ((Element)find(elt)).getIndex();
		} catch (NullPointerException x) {
			return -1;
		}
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("type "+getName()+"  [ ");
		Enumeration<NamedElement> en = elements();
		while (en.hasMoreElements()) {
			sb.append(en.nextElement().getName());
			sb.append(", ");
		}
		sb.deleteCharAt(sb.length()-2);
		sb.append("];");
		return sb.toString();
	}

	public int size() {
		return nextIndex;
	}

	public Element getByIndex(int i) {
		for ( Enumeration<NamedElement> e = elements(); e.hasMoreElements() ;  ) {
			NamedElement ne = e.nextElement();
			if (ne instanceof Element) {
				Element elt = (Element) ne;
				if (elt.getIndex()==i)
					return elt;
			}
		}
		return null;
	}

}
