package libpetri.structure.arcs;

import libpetri.structure.Place;
import libpetri.structure.Transition;
import libpetri.structure.state.State;

public class InputArc extends Arc {

	InputArc(Place place_, Transition trans_, Function f) {
		super(place_, trans_,f);
	}

	public boolean isEnabled(State s, int[] bindings) {
		return s.getPlaceState(place).containsAll(func.eval(bindings)) ;
	}

	@Override
	public String toString() {
		return "\n\t\tinput "+place.getName()+ func.toString(place.getDom(),trans) +";" ;
	}

	@Override
	public void fire(State s2, int [] bindings) {
		s2.removeFromPlaceState(place, func.eval(bindings));		
	}

	public ArcType getType() {
		return ArcType.INPUT;
	}

}
