package libpetri.structure.arcs;

import libpetri.structure.Place;
import libpetri.structure.Transition;
import libpetri.structure.state.State;

public class OutputArc extends Arc {
	
	
	public OutputArc(Place place_, Transition trans_, Function f) {
		super(place_, trans_,f);
	}

	public boolean isEnabled(State s,int [] binding) {
		// unless there are capacity limits on places, output arcs do not limit enabledness
		return true;
	}
	
	@Override
	public String toString() {
		return "\n\t\toutput "+place.getName()+ func.toString(place.getDom(),trans) +";" ;
	}
	
	public void fire(State s2, int[] binding) {
		s2.addToPlaceState(place, func.eval(binding));		
	}	
	
	public ArcType getType() {
		return ArcType.OUTPUT;
	}
}
