package libpetri.structure.state;

import libpetri.nets.Indexable;


public interface ComposedState<ComponentState extends Comparable> {

	public ComposedState<ComponentState> copy() ;
	
	public int getSize();
	
	public ComponentState getComponentState(Indexable part);
	public void setComponentState(Indexable part, ComponentState s);
	public void addToComponentState(Indexable part, ComponentState s);
	public void removeFromComponentState(Indexable part, ComponentState s);
	
	public ComponentState getComponentState(int partIndex);
	public void setComponentState(int partIndex, ComponentState s);
	public void addToComponentState(int partIndex, ComponentState s);
	public void removeFromComponentState(int partIndex, ComponentState s);
	
}
