package libpetri.structure.state;

import libpetri.structure.Domain;
import libpetri.tensor.ITensorIterator;
import libpetri.tensor.Tensor;

public class PlaceState {

	Tensor t;
	
	public PlaceState(int []dims) {
		t = new Tensor(dims);
	}
	
	public PlaceState(Tensor tensor) {
		t = tensor;
	}

	boolean contains(int [] elt,int card) {
		assert(card==1);
		return t.contains(elt);
	}

	public void add(int[] elt,int card) {
		// unimplemented for card > 1
		assert(card ==1);
		t.add(elt);
	}
	void remove(int [] elt,int card) {
		assert(card ==1);
		t.remove(elt);
	}
	
	@Override
	public String toString() {
		return t.toString();
	}

	public boolean isEmpty() {
		return t.isEmpty();
	}

	public boolean contains(Tensor tensor) {
		return t.containsAll(tensor);
	}

	public String toString(Domain dom) {
		if (t.isEmpty())
			return "";
		StringBuffer sb = new StringBuffer(128);
		ITensorIterator it = t.getIterator();
		while (it.hasNext()) {
			int [] coord = it.next();
			if (coord.length == 0)
				sb.append(" 1 ");
			else
				sb.append(" 1'< ");
			for (int cl = 0 ; cl < coord.length ; cl++ ) {
				sb.append(dom.get(cl).getByIndex(coord[cl]));
				sb.append(",");
			}
			if (coord.length != 0)
				sb.setCharAt(sb.length()-1, '>');
			sb.append(" +");
		}
		// kill the last + character
		return sb.substring(0, sb.length()-1);
	}

	public boolean containsAll(PlaceState tf) {
		return t.containsAll(tf.t);
	}

	public void removeAll(PlaceState tf) {
		t.removeAll(tf.t);
	}


}
