package libpetri.structure.state;

import java.lang.ref.WeakReference;
import java.util.Arrays;
import java.util.WeakHashMap;

public class UniqueArrayHelper {

	private static WeakHashMap<Array, WeakReference<Array>> unique = new WeakHashMap<Array, WeakReference<Array>>(); 
	public static int [] unique (int [] val) {
		Array a = new Array(val);
		WeakReference<Array> b = unique.get(a);
		if (b == null) {
			// new 
			unique.put(a,new WeakReference<Array>(a));
			return a.tab;
		} else {
			// known state
			return b.get().tab;
		}
	}
	
	public static String getStats() {
		return "Currently storing " + unique.size() + " unique int arrays.\n";
	}
}

/** encapsulate an int array to give it full class status for hash storage*/
class Array {
	int [] tab;
	public Array(int [] tab) {
		this.tab = tab;
	}
	public int hashCode() {
		return Arrays.hashCode(tab);
	}
	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		return Arrays.equals(tab, ((Array)obj).tab);
	}
}