package libpetri.test;

import java.io.IOException;

import libpetri.ami.AMInet;
import libpetri.structure.Net;
import libpetri.structure.Visibility;

public class CliServSynchronous extends Net {

	public CliServSynchronous(String name) {
		super(name);

		createComponent(new Client("c"));
		createComponent(new Server("s"));
		
		createSynchronization("req", Visibility.PRIVATE);
		addSynchronize("req", "c.sendReq");
		addSynchronize("req", "s.getReq");
		
		createSynchronization("ack", Visibility.PRIVATE);
		addSynchronize("ack", "c.getAck");
		addSynchronize("ack", "s.sendAck");
		
	}

	public static void main(String[] args) {
		Net n  = new CliServSynchronous("cs");

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		n.generateStateSpace();
		unfold.generateStateSpace();
		
		try {
			AMInet a = new AMInet();
			unfold.convert(a);
			a.writeNet("CliServ.cami");
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("Fini");
	}

}
