package libpetri.test;

import java.util.Calendar;

import libpetri.structure.Net;
import libpetri.structure.Visibility;

public class NCliServSync extends Net {

	public NCliServSync(String name,int NCli) {
		super(name);


		createComponent(new Server("s"));

		for (int i=0;i<NCli;i++) {
			createComponent(new Client("c"+i));
			createSynchronization("req"+i, Visibility.PRIVATE);
			addSynchronize("req"+i, "c"+i+".sendReq");
			addSynchronize("req"+i, "s.getReq");

			createSynchronization("ack"+i, Visibility.PRIVATE);
			addSynchronize("ack"+i, "c"+i+".getAck");
			addSynchronize("ack"+i, "s.sendAck");
		}

	}

	public static void main(String[] args) {
		Net n  = new NCliServSync("cs",14);

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		{
			Calendar c = Calendar.getInstance();
			unfold.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");
		}
		{
			Calendar c = Calendar.getInstance();
			n.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");

		}


//		try {
//			AMInet a = new AMInet("NCliServ.cami");
//			unfold.toAMI(a);
//			a.close();
//		} catch (FileNotFoundException e) {
//			e.printStackTrace();
//		}
		System.out.println("Fini");
	}

}
