package libpetri.test;


import libpetri.structure.Net;
import libpetri.structure.Visibility;
import libpetri.structure.arcs.ArcType;

public class Server extends Net{
	
	public Server(String name) {
		super(name);
		
		createPlace("idle");
		createPlace("treat");
		createPlace("cleanup");
		
		createTransition("getReq",Visibility.PUBLIC);
		createArc("idle", "getReq", ArcType.INPUT);
		createArc("treat", "getReq", ArcType.OUTPUT);
		
		createTransition("sendAck",Visibility.PUBLIC);
		createArc("treat", "sendAck", ArcType.INPUT);
		createArc("cleanup", "sendAck", ArcType.OUTPUT);
		
		createTransition("doOperation",Visibility.PRIVATE);
		createArc("cleanup", "doOperation", ArcType.INPUT);
		createArc("idle", "doOperation", ArcType.OUTPUT);

		setPlaceState("idle","1");
	}

	public static void main(String[] args) {
		Net n = new Server("s1");
		
		System.out.println(n);
		
		n.generateStateSpace();
	}
}
