package libpetri.test.philo;

import libpetri.structure.Net;

/**
 * an example exhibiting strength of multi-level compression tables scheme. 
 * 216k states/ 70 Mo RAM peak overall program consumption / 400k s 
 * => 2ms /state average 
 * + 320 bytes/state IF WE CONSIDER ALL MEMORY IS IN STATES (wrong)(8 phil)
 * 	Nominal 8 philo state should be 
 * 7 places * sizeof int * 8 = 224 bytes, so it looks very good.
 * Memory grows slowly then stagnates once local states have been explored.
 * 
 *
 */
public class EightPhil extends PhilCompose {

	
	@Override
	public Net createP1component() {
		return new FourPhil("p1");
	}

	@Override
	public Net createP2component() {
		return new FourPhil("p2");
	}
	
	public EightPhil(String name) {
		super(name);
	}

	public static void main(String[] args) {
		Net n = new FourPhil("eight");
		System.out.println(n);
		n.generateStateSpace();

	}

	
	
}
