package libpetri.test.philo;

import java.io.FileNotFoundException;
import java.util.Calendar;

import libpetri.dot.DOTnet;
import libpetri.structure.Net;
import libpetri.structure.Visibility;


public class LonelyPhilo extends Net {

	public LonelyPhilo(String name) {
		super(name);

		createComponent(new Philo("p"));
		createComponent(new Fork("f"));
		createComponent(new Fork("fr"));
		
		createSynchronization("rightGet",Visibility.PRIVATE);
		addSynchronize("rightGet", "p.getRight");
		addSynchronize("rightGet", "f.get");

		createSynchronization("endEat",Visibility.PRIVATE);
		addSynchronize("endEat", "p.finishEat");
		addSynchronize("endEat", "f.put");
		addSynchronize("endEat", "fr.put");
		
		createSynchronization("leftGet",Visibility.PRIVATE);
		addSynchronize("leftGet", "p.getLeft");
		addSynchronize("leftGet", "fr.get");
				
	}

	public static void main(String[] args) {
		LonelyPhilo n = new LonelyPhilo("pf");

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		{
			Calendar c = Calendar.getInstance();
			unfold.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");
		}
		{
			Calendar c = Calendar.getInstance();
			n.generateStateSpace();
			Calendar c2 = Calendar.getInstance();
			System.out.println(" elapsed : "+ (c2.getTimeInMillis()-c.getTimeInMillis())+"ms");

		}
		
		try {
			DOTnet a = new DOTnet("LonelyPhilo");
			unfold.convert(a);
			a.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		System.out.println("Expected a total of 6 states. Time~0 ");

	}
}
