package libpetri.test.philo;

import libpetri.structure.Net;
import libpetri.structure.Visibility;
import libpetri.structure.arcs.ArcType;

public class Philo extends Net{
	
	public Philo(String name) {
		super(name);
		
		createPlace("think");
		createPlace("waitLeft");
		createPlace("waitRight");
		createPlace("hasLeft");
		createPlace("hasRight");
		createPlace("eat");
		
		createTransition("hungry",Visibility.PRIVATE);
		createArc("think", "hungry", ArcType.INPUT);
		createArc("waitLeft", "hungry", ArcType.OUTPUT);
		createArc("waitRight", "hungry", ArcType.OUTPUT);
		
		createTransition("getLeft",Visibility.PUBLIC);
		createArc("waitLeft", "getLeft", ArcType.INPUT);
		createArc("hasLeft", "getLeft", ArcType.OUTPUT);
		
		createTransition("getRight",Visibility.PUBLIC);
		createArc("waitRight", "getRight", ArcType.INPUT);
		createArc("hasRight", "getRight", ArcType.OUTPUT);
		
		createTransition("startEat",Visibility.PRIVATE);
		createArc("hasLeft", "startEat", ArcType.INPUT);
		createArc("hasRight", "startEat", ArcType.INPUT);
		createArc("eat", "startEat", ArcType.OUTPUT);
		
		createTransition("finishEat",Visibility.PUBLIC);
		createArc("eat", "finishEat", ArcType.INPUT);
		createArc("think", "finishEat", ArcType.OUTPUT);

		setPlaceState("think","1'<>");
	}

	public static void main(String[] args) {
		Net n = new Philo("philo1");
		
		System.out.println(n);
		
		n.generateStateSpace();
		
		System.out.println("Expected a total of 2 states. Time~0 ");
	}
}
