package libpetri.test.philo;

import libpetri.structure.Net;
import libpetri.structure.Visibility;


public class PhiloFork extends Net {

	public PhiloFork(String name) {
		super(name);

		createComponent(new Philo("p"));
		createComponent(new Fork("f"));

		// Link p and f with private synchros
		createSynchronization("rightGet",Visibility.PRIVATE);
		addSynchronize("rightGet", "p.getRight");
		addSynchronize("rightGet", "f.get");

		//		export left fork 
		createSynchronization("getLeft", Visibility.PUBLIC);
		addSynchronize("getLeft", "p.getLeft");
		
		createSynchronization("finishEat",Visibility.PUBLIC);
		addSynchronize("finishEat", "p.finishEat");
		addSynchronize("finishEat", "f.put");
		
		// export fork public transitions
		createSynchronization("get", Visibility.PUBLIC);
		addSynchronize("get", "f.get");
		
		createSynchronization("put", Visibility.PUBLIC);
		addSynchronize("put", "f.put");
		
		
				
	}

	public static void main(String[] args) {
		Net n = new PhiloFork("pf");

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		
		//		pf.generateStateSpace();
	}
}
