package libpetri.test.philo;

import java.io.FileNotFoundException;
import java.io.IOException;

import libpetri.ami.AMInet;
import libpetri.dot.DOTnet;
import libpetri.structure.Net;

public class TwoPhiloTable extends PhiloTable {

	public TwoPhiloTable(String name) {
		super(name);
	}


	public Net createPFcomponent() {
		Net n = new TwoPhil("pf");
		System.out.println(n);
		return n;
	}

	
	public static void main(String[] args) {
		Net n  = new TwoPhiloTable("tableForTwo");

		System.out.println(n);
		Net unfold = new Net("unfolded");
		n.flatten(unfold);
		System.out.println(unfold);
		n.generateStateSpace();
		unfold.generateStateSpace();
		
		try {
			AMInet a = new AMInet();
			unfold.convert(a);
			a.writeNet("TwoPhil.cami");
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			DOTnet a = new DOTnet("TwoPhil");
			unfold.convert(a);
			a.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		System.out.println("Expected a total of 22 states. Time~0 ");
	}

}
