package micropilot;

public class BoundsResult extends ServiceResult {
	public static final int INF = -1;
	private int lbound;
	private int hbound;
	 
	String umlString;
	
	public BoundsResult(int id, int lbound2, int hbound2) {
		super (id);
		lbound = lbound2;
		hbound = hbound2;
		if (lbound == 0 && hbound == 1) {
			// place is safe, looks ok
			level = Level.STATISTIC;
			umlString = "is reachable.";
		} else if (hbound == INF) {
			// place is unbounded ! we have a problem
			level = Level.ERROR;
			umlString = " is unbounded. Please check fork transitions above this element," +
					" an uncontrolled number of control flows could be active simultaneously in this element.";			
		} else if (lbound == hbound) {
			// place has fixed marking : unreachable or unconnected
			level = Level.ERROR;
			umlString = " is unreachable. It seems this element can never be active." +
			" It is either unreachable (dead-code) or disconnected from the rest of your model.";
		} else if (hbound > 1) {
			// place is not safe but still bounded : warn
			level = Level.WARNING;
			umlString = " is bounded in range :["+lbound+" ... "+hbound+"]. " +
					"For buffers or storage elements this could be normal," +
					" but please check this behavior (several simultaneously active flows here) is desired"; 			
		} else {
			level = Level.STATISTIC;
			umlString = toString();
		}
	}
	
	public String toString() {
		return ("Object "+macaoNum +" bounds : ["+lbound+" ... "+(hbound==INF?" +oo":hbound)+"]");
	}
	
	public String getDescription() {
		return umlString;
	}
}
