package micropilot;

import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import cami.FKCommand;

public class BoundsServiceHandler implements IServiceHandler {

	Pattern pat = Pattern.compile("^\\[(\\d+)\\s\\.\\.\\.\\s(\\d+|\\+oo)\\]$" );

	
	public void handleMessage(FKCommand fk, Vector<ServiceResult> ret) {
		switch (fk.getCode())  {
		case XA :
			int id = Integer.parseInt(fk.get(0));
			assert (fk.get(1).equals("ponderation"));
			String bounds = fk.get(2);
			Matcher matcher = pat.matcher(bounds);
//			boolean found = false;
			if (matcher.find()) {
				int lbound = Integer.parseInt(matcher.group(1));
				int hbound = BoundsResult.INF;
				try {
					hbound = Integer.parseInt(matcher.group(2));
				} catch (NumberFormatException e){
					// ok it's infinity
					// System.err.println("caught infinity");
				}
				ret.add (new BoundsResult (id,lbound,hbound));
			}
			
		}
	}

}
