package micropilot;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class ConnectionSettings implements java.io.Serializable {
	private String userName = "modelplex";
	private String password = "123456";
	private String host ="hephaistos.lip6.fr";
	private int port =7001;
	private String APIName ="MICRO-PILOT";
	private String version = "3.0";
	private String modelPath = "C:/workspace-together/dmc-java/SalesOrderProcessingSAP3.cami";
	
	public String toString() {
		return "[user="+userName+"][pass="+password
			+"][host="+host+"][port="+port+"][Api="+APIName+"-"+version+"]";
	}
	
	public String getUserName() {
		return userName;
	}
	public String getPassword() {
		return password;
	}
	public String getHost() {
		return host;
	}
	public int getPort() {
		return port;
	}
	public String getAPIName() {
		return APIName;
	}
	public String getVersion() {
		return version;
	}

	public ICamiModel getModel() {
		return new CamiFileModel(modelPath) ;
	}
	public void setModelFile(String path) {
		modelPath = path;
	}
	
	public JPanel getConfPanel () {
		JPanel tmp = new JPanel();
		tmp.add(new ConfPanel());
		return tmp;
	}
	
	class ConfPanel extends JPanel implements ActionListener {
		JButton ok = new JButton( "OK");
		JButton cancel = new JButton( "Cancel");
		JTextField fuser = new JTextField(20);
		JPasswordField fpass = new JPasswordField(20);
		JTextField fhost = new JTextField(20);;
		JTextField fport =new JTextField(20);
		
		public ConfPanel() {
			super(new BorderLayout());
			JPanel saisie = new JPanel(new GridLayout(4,2));
			
			updateFromConf();
			
			saisie.add(new JLabel("User Name :"));
			saisie.add(fuser);
			saisie.add(new JLabel("Password :"));
			saisie.add(fpass);
			saisie.add(new JLabel("Host :"));
			saisie.add(fhost);
			saisie.add(new JLabel("Port :"));
			saisie.add(fport);

			add("Center",saisie);
			
			JPanel butt = new JPanel();
			butt.add(cancel);
			cancel.addActionListener(this);
			butt.add(ok);
			ok.addActionListener(this);
			
			add("South",butt);
		}

		private void updateFromConf() {
			fuser.setText(userName);
			fpass.setText(password);
			fhost.setText(host);
			fport.setText(Integer.toString(port));
		}
		
		private void setToConf() {
			userName = fuser.getText();
			password = new String(fpass.getPassword());
			host = fhost.getText();
			port = Integer.parseInt(fport.getText());
		}

		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == ok) 
				setToConf();
			else if (e.getSource() == cancel)
				updateFromConf();
		}
	}
	
	public static void main(String[] args) {
		JFrame jf = new JFrame("Default Connection Settings");
		jf.setSize(600,400);
		ConnectionSettings cs= new ConnectionSettings();
		jf.setContentPane(cs.getConfPanel());
		jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jf.setVisible(true);
	}

	public String getModelName() {
		return new File(modelPath).getName();
	}

	
}
