package micropilot;

public enum Service {
	SYNTAX_CHECKER ("AMI-Net","AMI-Net","Petri net syntax checker"),
	STRUCTURAL_BOUNDS("AMI-Net", "Structural properties","Compute structural bounds") ,
	IS_STRUCTURALLY_BOUNDED("AMI-Net", "Structural properties","Is the net structurally bounded?"),
	PLACE_INVARIANTS("AMI-Net", "Structural properties","P-invariants"),
	TRANS_INVARIANTS("AMI-Net", "Structural properties","T-invariants"),
	LTL_DEADLOCKS("AMI-Net", "Behavioral Properties","Does the system have deadlocks"),
	MIN_SYPHON("AMI-Net", "Structural properties","Minimal syphon"),
	MIN_TRAPS("AMI-Net", "Structural properties","Minimal traps"),
	BOOL_CONDITIONS("AMI-Net", "Behavioral Properties","Boolean conditions over place marking")
	;
	private final String root;
	private final String parent;
	private final String name;
	private Service(String root,String parent,String name) {
		this.root = root;
		this.parent = parent;
		this.name = name;
	}
	public String getName() {
		return name;
	}
	public String getParent() {
		return parent;
	}
	public String getRoot() {
		return root;
	}
	public IServiceHandler getServiceHandler () {
		switch (this) {
		case SYNTAX_CHECKER :
			return new SyntaxCheckerServiceHandler();
		case STRUCTURAL_BOUNDS :
			return new BoundsServiceHandler();
		default :
			return new DefaultServiceHandler();
		}
	}
	
}
