package multi;

import basic.StateSetArrayAdapter;
import basic.FiringManagerThread;
import basic.StateManagerHashSetAdapter;
import interfaces.AbstractController;
import interfaces.IFiringManager;
import interfaces.IModelFactory;
import interfaces.IStateManager;
import interfaces.IStateSet;

public class MultiThreadController extends AbstractController {

	private int nbthreads;

	public MultiThreadController(IModelFactory mf,int nbthreads) {
		super(mf);
		this.nbthreads =nbthreads;
		initialize();
	}


	protected IStateManager createStateManager() {
		return new StateManagerHashSetAdapter (nss_);
	}

	
	protected IStateSet createStateSet() {
		StateSetArrayAdapter ass = new StateSetArrayAdapter ();		
		return ass;
	}

	protected IFiringManager createFiringManager() {
		if (nbthreads == 1 )
			return new FiringManagerThread(nss_,sm_,mf_);
		else
			return new FiringManagerMultiThread (nss_,sm_,mf_,nbthreads);
			
	}
	
	public void close() {
		fm_.close();
		return;
	}

}
