package net;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;

public class TCPClient {

	private static final boolean DEBUG = true;
	protected InetAddress servAdr;
	protected int servPort;
	protected Socket sock;

	public TCPClient ()  {
		try {
			servAdr = InetAddress.getByName("localhost");
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
	}


	public void setServer(InetAddress servAdr, int port) {
		this.servAdr = servAdr;
		servPort = port;		
	}
	public void setServer (String servAdr,int portServ) throws UnknownHostException {
		this.servAdr = InetAddress.getByName(servAdr);
		servPort = portServ ;
	}

	public void connect () throws IOException {
		// no stop condition, we throw an exception on 3rd error
		for (int i=1; /*i<4*/ ; i++ )
			try {
				sock = new Socket (servAdr,servPort);
				if (DEBUG) 
					System.err.println ("Client connected to "+servAdr.getHostAddress()
							+":"+servPort);
				return ;
			} catch (IOException e) {
				System.err.println("Try "+i+" :Error connecting to "+servAdr.getHostAddress()
						+":"+servPort);
				if (i == 3) throw e;
				try {
					Thread.sleep(1000*i);
				} catch (InterruptedException e1) {
					e1.printStackTrace();
				}
			}			
	}

	public String toString () {
		if (sock != null && sock.isConnected())
			return "TCP client connected to host="+ servAdr.getHostName() + ":" + servPort;
		else
			return "Disconnected TCP client";
	}
	
	public void disconnect () {
		try {
			sock.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
