package protocol;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import net.TCPClient;

public class TCPClientMessage extends TCPClient implements IMessageConnection<Message> {

	private ObjectInputStream in;
	private ObjectOutputStream out;

	public synchronized void connect () throws IOException {
		super.connect();
		out = new ObjectOutputStream(sock.getOutputStream());
		in = new ObjectInputStream(new BufferedInputStream(sock.getInputStream()));	
	}

	public synchronized Message getMessage() throws IOException {
			try {
				Message m = (Message) in.readObject();
				if (m.head == MsgType.QUIT) {
					disconnect();
				}
				return m;
			}  catch (ClassNotFoundException e) {
				throw new IOException("Protocol Message layer error :"+e);
			}	
	}

	public synchronized void sendMessage(Message m) throws IOException {
		out.writeObject(m);
	}

	public void disconnect() {
		try {
			sendMessage(new Message(MsgType.QUIT));
			out.flush();
		} catch (IOException e) {
			e.printStackTrace();
		}
		super.disconnect();
	}
}
