package protocol;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import net.TCPServer;

public abstract class TCPServeurMessage extends TCPServer implements IMessageConnection<Message>{

	private ObjectInputStream in;
	private ObjectOutputStream out;
	private Socket client_;

	
	public void handleClient(Socket client) {
		try {
			client_ = client;
			out = new ObjectOutputStream(client.getOutputStream());
			in = new ObjectInputStream(new BufferedInputStream(client.getInputStream()));
			gereClient();
		} catch (IOException e) {
			System.out.println( e ) ;
			System.out.println("Terminaison anormale de la connexion couche communication par Message. " +
					"Ce Thread de traitement d'un client va se terminer.");
		}
	}

	/** A surcharger par les utilisateurs */
	abstract public void gereClient() ;

	/** Appel bloquant si pas de message  lire 
	 * @return le message lu
	 * */
	public Message getMessage () throws IOException { 
		try {
			Message m = (Message) in.readObject();
			if (m.head == MsgType.QUIT) {
				client_.close();
			}
			return m;
		} catch (ClassNotFoundException e) {
			throw new IOException(e.toString());
		}
	}
	
	/** Appel bloquant si la connection est sature. En gnral, non bloquant. 
	 * @param m le message  mettre
	 * @throws IOException 
	 * */
	public void sendMessage (Message m) throws IOException {
		out.writeObject(m);
	}
	
}
