package transform;


import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.File;
import java.io.Serializable;

import javax.swing.JPanel;
import javax.swing.JTextArea;

import transform.gui.ChoosableFilePanel;
import transform.gui.ExtensionFileFilter;


public class Configuration implements Serializable {

	class ConfigurationGUI extends JPanel implements BasicObserver {

		private JTextArea error_text;
		private ChoosableFilePanel modelPanel;
//		private ChoosableFilePanel libUMLPanel;


		public ConfigurationGUI() {
			super(new BorderLayout());

//			error_text = new JTextArea(5,80);
//			error_text.setLineWrap(true);
//			error_text.setBackground(Color.LIGHT_GRAY);
//			add ("South",error_text);

			JPanel centerPanel = new JPanel(new GridLayout(2,2));
			modelPanel = new ChoosableFilePanel("Source Model :",modelPath,new ExtensionFileFilter("UML model file","uml"),error_text);
			modelPanel.addObserver(this);
			centerPanel.add(modelPanel);

			
			
//			libUMLPanel = new ChoosableFilePanel("UML2 library jar resource :",libUMLPath,new ExtensionFileFilter("org.eclipse.uml2.uml_XXX.jar","jar"),error_text);
//			libUMLPanel.addObserver(this);
//			centerPanel.add(libUMLPanel);
			
			
			add("Center",centerPanel);
			
		}

		public void updateConfiguration() {
			setModelPath(modelPanel.getPath());
//			setLibUMLPath(libUMLPanel.getPath());
		}

		public void update(Object arg) {
			updateConfiguration();
		}



	}

	public JPanel getConfPanel () {
		JPanel tmp = new JPanel();
		tmp.add(new ConfigurationGUI());
		return tmp;
	}
	
	/** the path to the source UML model file */
	private String modelPath=System.getProperty("user.dir") +"/models/SAP/SalesOrderProcessingSAP.uml";

	public void setModelPath(String path) {
		modelPath = path ;
	}
	public String getModelPath() {
		return modelPath;
	}
	public String getModelName() {
		String n = new File(modelPath).getName();
		return (n.substring(0, n.length()-4));
	}

	public String getWorkingDir() {
		return new File(modelPath).getParent();
	}
	
//	/** the path to the UML library jar file */
//	private String libUMLPath="jar:file:"+System.getProperty("user.dir") +"/lib/org.eclipse.uml2.uml_2.1.1.v200707311200.jar!/";
//	public String getLibUMLPath() {
//		return libUMLPath;
//	}
//	public void setLibUMLPath(String libUMLPath) {
//		this.libUMLPath = libUMLPath;
//	}

	private String camiPath ;
	
	public void setCamiPath(String camiPath) {
		this.camiPath = camiPath;
	}
	
	public String getTempCamiPath() {
		if (camiPath == null)
			return getModelPath() + ".petri" ;
		else
			return camiPath;
	}
	

}
