package transform.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StreamCorruptedException;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

import transform.BasicObserver;

public 	class ChoosableFilePanel extends JPanel  implements ActionListener {
	private JButton choose;
	private JTextField path;
	private FileFilter filt;
	private JTextArea error_text;

	public ChoosableFilePanel(String title, String defaultPath, FileFilter fileFilt, JTextArea err) {
		super();
		add(new JLabel(title));
		filt = fileFilt ;


		path  = new JTextField(60);
		path.setText(defaultPath);
		path.setEditable(false);
		add(path);

		choose = new JButton ("Select...");
		choose.addActionListener(this);
		add(choose);

		error_text = err;
	}

	public void actionPerformed(ActionEvent e) {
		Object source = e.getSource();
		if (source == choose) {
			JFileChooser chooser = new JFileChooser(System.getProperty("user.dir"));
			chooser.setFileFilter(filt);
			int returnVal = chooser.showOpenDialog(this);
			if(returnVal == JFileChooser.APPROVE_OPTION) {
				String pathstr = null ;
				try {
					pathstr = chooser.getSelectedFile().getCanonicalPath();
					System.out.println("You chose to open this file: " + pathstr);
					path.setText(pathstr);
					hasChanged();
				} catch (FileNotFoundException e1) {
					error_text.setText( "Configuration load failed due bad file name error :"+path+"\n"+e1);
				} catch (StreamCorruptedException e2) {
					error_text.setText( "Configuration load failed due to bad file format. \n Are you sure this is a save file ? ");
				} catch (IOException e3) {						
					error_text.setText( "Configuration load failed due to exception : " +e3);
				}
			}
		}
	}

	public String getPath() {
		return path.getText();
	}

	Vector<BasicObserver> obs = new Vector<BasicObserver> ();
	public void addObserver(BasicObserver o) {
		obs.add(o);
	}
	private void hasChanged () {
		for (BasicObserver o:obs)
			o.update(this);
	}
}